"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = bytesToUtf8;

function bytesToUtf8(bytes) {
  var codeUnits = [];
  var codePoint = 0;
  var utf8 = '';

  var _byte = -1;

  for (var i = 0; i < bytes.length; i++) {
    _byte = bytes[i];

    if (_byte < 0x80) {
      codeUnits.push(bytes[i]);
    } else if (_byte < 0xe0) {
      codePoint = ((bytes[i] & 31) << 6) + (bytes[++i] & 63);
      codeUnits.push(codePoint);
    } else if (_byte < 0xf0) {
      codePoint = ((bytes[i] & 15) << 12) + ((bytes[++i] & 63) << 6) + (bytes[++i] & 63);
      codeUnits.push(codePoint);
    } else {
      codePoint = ((bytes[i] & 7) << 18) + ((bytes[++i] & 63) << 12) + ((bytes[++i] & 63) << 6) + (bytes[++i] & 63);
      codePoint -= 0x10000;
      codeUnits.push((codePoint >> 10) + 0xd800, codePoint % 0x400 + 0xdc00);
    }

    if (codeUnits.length > 0x3fff) {
      utf8 += String.fromCharCode.apply(null, codeUnits);
      codeUnits.length = 0;
    }
  }

  utf8 += String.fromCharCode.apply(null, codeUnits);
  return utf8;
}

module.exports = exports.default;