"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = utf8ToBytes;

function utf8ToBytes(str) {
  var bytes = [];

  for (var i = 0; i < str.length; i++) {
    var code = str.charCodeAt(i);

    if (code < 0x007f) {
      bytes.push(code);
    } else if (code < 0x07ff) {
      var b1 = code >> 6 | 192;
      var b2 = code & 63 | 128;
      bytes.push(b1, b2);
    } else if (code >= 0xd800 && code <= 0xdbff) {
      var high = code;
      i++;
      var low = str.charCodeAt(i);
      code = 0x10000 + (high - 0xd800) * 0x400 + low - 0xdc00;

      var _b = code >> 18 | 240;

      var _b2 = code >> 12 & 63 | 128;

      var b3 = code >> 6 & 63 | 128;
      var b4 = code & 63 | 128;
      bytes.push(_b, _b2, b3, b4);
    } else {
      var _b3 = code >> 12 | 224;

      var _b4 = code >> 6 & 63 | 128;

      var _b5 = code & 63 | 128;

      bytes.push(_b3, _b4, _b5);
    }
  }

  return bytes;
}

module.exports = exports.default;