"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ajax;

var _isObject = _interopRequireDefault(require("./lang/isObject"));

var _isString = _interopRequireDefault(require("./lang/isString"));

function ajax(url) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return new Promise(function (resolve, reject) {
    var _options$async = options.async,
        async = _options$async === void 0 ? true : _options$async,
        _options$beforeSend = options.beforeSend,
        beforeSend = _options$beforeSend === void 0 ? function () {} : _options$beforeSend,
        _options$data = options.data,
        data = _options$data === void 0 ? null : _options$data,
        _options$headers = options.headers,
        headers = _options$headers === void 0 ? {} : _options$headers,
        _options$method = options.method,
        method = _options$method === void 0 ? 'get' : _options$method,
        _options$responseType = options.responseType,
        responseType = _options$responseType === void 0 ? 'json' : _options$responseType,
        _options$timeout = options.timeout,
        timeout = _options$timeout === void 0 ? 0 : _options$timeout;
    var xhr = new XMLHttpRequest();
    xhr.open(method, url, async);
    var timerId;

    if (timeout) {
      timerId = window.setTimeout(function () {
        reject(new Error("the xhr request timeout ".concat(timeout, "ms")));
      }, timeout);
    }

    xhr.onerror = function () {
      reject(new Error('unknown error'));
    };

    xhr.onreadystatechange = function () {
      if (xhr.readyState === 4) {
        if (timeout && timerId !== undefined) clearTimeout(timerId);

        if (xhr.status >= 200 && xhr.status < 300) {
          resolve(xhr);
        } else {
          var err = new Error('the request is error');
          reject(err);
        }
      }
    };

    var sendData = null;

    if ((0, _isObject["default"])(data)) {
      try {
        sendData = JSON.stringify(data);
        headers['content-type'] = 'application/json';
      } catch (err) {
        reject(err);
      }
    } else if ((0, _isString["default"])(data)) {
      headers['content-type'] = 'application/x-www-form-urlencoded';
    }

    for (var _key in headers) {
      xhr.setRequestHeader(_key, headers[_key]);
    }

    if (timeout) {
      xhr.timeout = timeout;
    }

    xhr.responseType = responseType;

    if (beforeSend(xhr) !== false) {
      xhr.send(sendData);
    }
  });
}

module.exports = exports.default;