"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = decode;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _bytesToHex = _interopRequireDefault(require("../_internal/bytesToHex"));

var _bytesToUtf = _interopRequireDefault(require("../_internal/bytesToUtf8"));

var _isString = _interopRequireDefault(require("../lang/isString"));

var base64Chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
var base64Map = {};
var bitPadding = '000000';

for (var i = 0; i < base64Chars.length; i++) {
  var ch = base64Chars.charAt(i);
  base64Map[ch] = i;
}

function base64ToBytes(str) {
  var bits = '';

  for (var _i = 0; _i < 4; _i++) {
    var _ch = str.charAt(_i);

    var index = base64Map[_ch];

    if (index > -1) {
      var bitStr = index.toString(2);
      var pad = bitPadding.slice(0, 6 - bitStr.length);
      bits += pad + bitStr;
    }
  }

  var bytes = [];

  for (var _i2 = 0, len = Math.floor(bits.length / 8); _i2 < len; _i2++) {
    bytes.push(parseInt(bits.slice(_i2 * 8, (_i2 + 1) * 8), 2));
  }

  return bytes;
}

function decode(input) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (!(0, _isString["default"])(input)) {
    throw TypeError('input parameter should be a string');
  }

  var _options$encoding = options.encoding,
      encoding = _options$encoding === void 0 ? 'utf8' : _options$encoding;
  var bytes = [];

  for (var _i3 = 0, len = Math.ceil(input.length / 4); _i3 < len; _i3++) {
    bytes.push.apply(bytes, (0, _toConsumableArray2["default"])(base64ToBytes(input.slice(_i3 * 4, (_i3 + 1) * 4))));
  }

  if (encoding === 'binary') {
    return bytes;
  } else if (encoding === 'hex') {
    return (0, _bytesToHex["default"])(bytes);
  }

  return (0, _bytesToUtf["default"])(bytes);
}

module.exports = exports.default;