"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = css;

var _isString = _interopRequireDefault(require("./lang/isString"));

var _isObject = _interopRequireDefault(require("./lang/isObject"));

var _isElement = _interopRequireDefault(require("./dom/isElement"));

function css(el, prop) {
  var elem;

  if ((0, _isString["default"])(el)) {
    elem = document.querySelector(el);

    if (!elem) {
      throw new Error('the element is not exist');
    }
  } else if ((0, _isElement["default"])(el)) {
    elem = el;
  } else {
    throw new Error('the 1st argument must be a css selector or an element');
  }

  if ((0, _isObject["default"])(prop)) {
    var cssText = elem.style.cssText;
    Object.keys(prop).forEach(function (name) {
      cssText += "".concat(name, ": ").concat(prop[name], ";");
    });
    elem.style.cssText = cssText;
  } else {
    var ret = window.getComputedStyle(elem);

    if ((0, _isString["default"])(prop)) {
      // @ts-ignore
      ret = ret[prop];
    }

    return ret;
  }
}

module.exports = exports.default;