"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _isDate = _interopRequireDefault(require("../lang/isDate"));

var _isNumber = _interopRequireDefault(require("../lang/isNumber"));

var _isString = _interopRequireDefault(require("../lang/isString"));

var _padStart = _interopRequireDefault(require("../_internal/padStart"));

var dateFormat = function dateFormat(date, format, isUTC) {
  if (!(0, _isNumber["default"])(date) && !(0, _isString["default"])(date) && !(0, _isDate["default"])(date)) {
    throw new Error('The first parameter should be a number, a parsable date string or a Date object');
  }

  var d;

  if ((0, _isNumber["default"])(date) || (0, _isString["default"])(date)) {
    d = new Date(date);
  } else {
    d = date;
  }

  if (!(0, _isString["default"])(format)) {
    return d.toString();
  }

  var year = isUTC ? d.getUTCFullYear() : d.getFullYear();
  var month = isUTC ? d.getUTCMonth() : d.getMonth();
  var day = isUTC ? d.getUTCDate() : d.getDate();
  var hour = isUTC ? d.getUTCHours() : d.getHours();
  var hour12 = hour % 12;
  var amOrPm = hour < 12 ? 'AM' : 'PM';
  var minute = isUTC ? d.getUTCMinutes() : d.getMinutes();
  var second = isUTC ? d.getUTCSeconds() : d.getSeconds();
  var millisecond = isUTC ? d.getUTCMilliseconds() : d.getMilliseconds();
  return format.replace(/(^|[^Y])YYYY([^Y]|$)/g, "$1".concat(year, "$2")).replace(/(^|[^Y])YY([^Y]|$)/g, "$1".concat(String(year).slice(-2), "$2")).replace(/(^|[^M])MM([^M]|$)/g, "$1".concat((0, _padStart["default"])(month + 1, 2, '0'), "$2")).replace(/(^|[^M])M([^M]|$)/g, "$1".concat(month, "$2")).replace(/(^|[^D])DD([^D]|$)/g, "$1".concat((0, _padStart["default"])(day, 2, '0'), "$2")).replace(/(^|[^D])D([^D]|$)/g, "$1".concat(day, "$2")).replace(/(^|[^H])HH([^H]|$)/g, "$1".concat((0, _padStart["default"])(hour, 2, '0'), "$2")).replace(/(^|[^H])H([^H]|$)/g, "$1".concat(hour, "$2")).replace(/(^|[^h])hh([^h]|$)/g, "$1".concat((0, _padStart["default"])(hour12, 2, '0'), "$2")).replace(/(^|[^h])h([^h]|$)/g, "$1".concat(hour12, "$2")).replace(/(^|[^A])A([^A]|$)/g, "$1".concat(amOrPm, "$2")).replace(/(^|[^a])a([^a]|$)/g, "$1".concat(amOrPm.toLowerCase(), "$2")).replace(/(^|[^m])mm([^m]|$)/g, "$1".concat((0, _padStart["default"])(minute, 2, '0'), "$2")).replace(/(^|[^m])m([^m]|$)/g, "$1".concat(minute, "$2")).replace(/(^|[^s])ss([^s]|$)/g, "$1".concat((0, _padStart["default"])(second, 2, '0'), "$2")).replace(/(^|[^s])s([^s]|$)/g, "$1".concat(second, "$2")).replace(/(^|[^S]+)([S]+)([^S]+|$)/g, function (match, s1, s2, s3) {
    var msStr = (0, _padStart["default"])(String(millisecond), 3, '0');

    for (var i = 3; i < s2.length; i++) {
      msStr += '0';
    }

    msStr = msStr.slice(0, s2.length);
    return "".concat(s1).concat(msStr).concat(s3);
  });
};

var _default = dateFormat;
exports["default"] = _default;
module.exports = exports.default;