"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = parse;

var _isDate = _interopRequireDefault(require("../lang/isDate"));

var _isNumber = _interopRequireDefault(require("../lang/isNumber"));

var _isString = _interopRequireDefault(require("../lang/isString"));

function parse(date) {
  var isUTC = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  if (!(0, _isNumber["default"])(date) && !(0, _isString["default"])(date) && !(0, _isDate["default"])(date)) {
    throw new Error('The first parameter should be a number, a parsable date string or a Date object');
  }

  var d;

  if ((0, _isNumber["default"])(date) || (0, _isString["default"])(date)) {
    d = new Date(date);
  } else {
    d = date;
  }

  return {
    years: isUTC ? d.getUTCFullYear() : d.getFullYear(),
    months: isUTC ? d.getUTCMonth() : d.getMonth(),
    dates: isUTC ? d.getUTCDate() : d.getDate(),
    hours: isUTC ? d.getUTCHours() : d.getHours(),
    minutes: isUTC ? d.getUTCMinutes() : d.getMinutes(),
    seconds: isUTC ? d.getUTCSeconds() : d.getSeconds(),
    milliseconds: isUTC ? d.getUTCMilliseconds() : d.getMilliseconds()
  };
}

module.exports = exports.default;