"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _hasOwn = _interopRequireDefault(require("../_internal/hasOwn"));

var _en_US = _interopRequireDefault(require("./i18n/timeAgo/en_US"));

var _zh_CN = _interopRequireDefault(require("./i18n/timeAgo/zh_CN"));

var locales = {
  en_US: _en_US["default"],
  zh_CN: _zh_CN["default"]
};
var currentLocale = 'en_US';
var timeAgo = {
  getLocale: function getLocale() {
    return currentLocale;
  },
  setLocale: function setLocale(name) {
    /* istanbul ignore else */
    if ((0, _hasOwn["default"])(locales, name)) {
      currentLocale = name;
    }
  },
  addLocale: function addLocale(name, locale) {
    locales[name] = locale;
  },
  format: function format(date) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : currentLocale;
    var nowDate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Date();
    var d = new Date(date);
    var actualLocale = (0, _hasOwn["default"])(locales, locale) ? locale : currentLocale;
    var sign = nowDate.getTime() - d.getTime() >= 0 ? 1 : -1;
    var diff = Math.abs(nowDate.getTime() - d.getTime());
    var years = Math.floor(diff / (365 * 24 * 60 * 60 * 1000));
    var months = Math.floor(diff / (30 * 24 * 60 * 60 * 1000));
    var weeks = Math.floor(diff / (7 * 24 * 60 * 60 * 1000));
    var days = Math.floor(diff / (24 * 60 * 60 * 1000));
    var hours = Math.floor(diff / (60 * 60 * 1000));
    var minutes = Math.floor(diff / (60 * 1000));
    var seconds = Math.floor(diff / 1000);
    var index = 0;
    var number = 0;

    if (seconds === 0) {
      index = 0;
      number = 0;
    } else if (seconds >= 1 && minutes === 0) {
      index = 1;
      number = seconds;
    } else if (minutes === 1) {
      index = 2;
      number = minutes;
    } else if (minutes > 1 && hours === 0) {
      index = 3;
      number = minutes;
    } else if (hours === 1) {
      index = 4;
      number = hours;
    } else if (hours > 1 && days === 0) {
      index = 5;
      number = hours;
    } else if (days === 1) {
      index = 6;
      number = days;
    } else if (days > 1 && weeks === 0) {
      index = 7;
      number = days;
    } else if (weeks === 1) {
      index = 8;
      number = weeks;
    } else if (weeks > 1 && months === 0) {
      index = 9;
      number = weeks;
    } else if (months === 1) {
      index = 10;
      number = months;
    } else if (months > 1 && years === 0) {
      index = 11;
      number = months;
    } else if (years === 1) {
      index = 12;
      number = years;
    } else {
      index = 13;
      number = years;
    }

    var tmplPair = locales[actualLocale][index];
    var tmpl = sign > 0 ? tmplPair[0] : tmplPair[1];
    return tmpl.replace(/%s/, String(number));
  }
};
var _default = timeAgo;
exports["default"] = _default;
module.exports = exports.default;