"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = domReady;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

/**
 * domready (c) Dustin Diaz 2014 - License MIT
 */
var fns = [];
var doc = (typeof document === "undefined" ? "undefined" : (0, _typeof2["default"])(document)) === 'object' && document; // @ts-ignore

var hack = doc && doc.documentElement.doScroll;
var domContentLoaded = 'DOMContentLoaded';
var loaded = doc && (hack ?
/* istanbul ignore next */
/^loaded|^c/ : /^loaded|^i|^c/).test(doc.readyState);

var _listener;
/* istanbul ignore else */


if (!loaded && doc) {
  _listener = function listener() {
    var fn = fns.shift();
    doc.removeEventListener(domContentLoaded, _listener);
    loaded = true;

    while (fn) {
      fn();
      fn = fns.shift();
    }
  };

  doc.addEventListener(domContentLoaded, _listener);
}

function domReady(fn) {
  if (loaded) {
    setTimeout(fn, 0);
  } else {
    fns.push(fn);
  }
}

module.exports = exports.default;