"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = isInViewport;

var _isElement = _interopRequireDefault(require("./isElement"));

var _viewport2 = _interopRequireDefault(require("./viewport"));

function isInViewport(el) {
  if (!(0, _isElement["default"])(el)) return false;

  var _el$getBoundingClient = el.getBoundingClientRect(),
      top = _el$getBoundingClient.top,
      left = _el$getBoundingClient.left,
      right = _el$getBoundingClient.right,
      bottom = _el$getBoundingClient.bottom;

  var _viewport = (0, _viewport2["default"])(window),
      width = _viewport.width,
      height = _viewport.height;

  return !(top < 0 || bottom > height || left < 0 || right > width);
}

module.exports = exports.default;