"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = viewport;

var _isWindow = _interopRequireDefault(require("./isWindow"));

var _isElement = _interopRequireDefault(require("./isElement"));

// TODO: default value is window
function viewport(elOrWindow) {
  var width = 0;
  var height = 0;

  if ((0, _isWindow["default"])(elOrWindow)) {
    var win = elOrWindow;
    width = win.innerWidth ||
    /* istanbul ignore next */
    win.document.documentElement.clientWidth;
    height = win.innerHeight ||
    /* istanbul ignore next */
    win.document.documentElement.clientHeight;
  } else if ((0, _isElement["default"])(elOrWindow)) {
    var el = elOrWindow;
    width = el.clientWidth;
    height = el.clientHeight;
  }

  return {
    width: width,
    height: height
  };
}

module.exports = exports.default;