"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _flattenEvents = _interopRequireDefault(require("./util/flattenEvents"));

var EVENTS_KEY = '@events';

var Emitter = /*#__PURE__*/function () {
  function Emitter() {
    (0, _classCallCheck2["default"])(this, Emitter);
    (0, _defineProperty2["default"])(this, EVENTS_KEY, void 0);
    this[EVENTS_KEY] = {};
  } // Add a listener for a given event.


  (0, _createClass2["default"])(Emitter, [{
    key: "on",
    value: function on(type, fn) {
      ;
      (this[EVENTS_KEY][type] = this[EVENTS_KEY][type] || []).push(fn);
    } // Add a listener for a given event.
    // This listener can be called once, then will be removed.

  }, {
    key: "once",
    value: function once(type, fn) {
      var wrapped = function wrapped() {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        // @ts-ignore
        return fn.apply(this, args);
      };

      wrapped.$once = true;
      this.on(type, wrapped);
    } // Remove all event listeners
    // or remove the given event listeners
    // or remove the specified listener for the given event.

  }, {
    key: "off",
    value: function off(type, fn) {
      // @ts-ignore
      var events = this[EVENTS_KEY][type];

      if (arguments.length === 0) {
        this[EVENTS_KEY] = {};
      } else if (arguments.length === 1) {
        // @ts-ignore
        delete this[EVENTS_KEY][type];
      } else {
        /* istanbul ignore else */
        if (events) {
          var len = events.length;
          var i = 0;
          var listener;

          while (i < len) {
            listener = events[i];

            if (listener === fn) {
              events.splice(i, 1);
              len--;
            } else {
              i++;
            }
          }

          if (!events.length) {
            // @ts-ignore
            delete this[EVENTS_KEY][type];
          }
        }
      }
    } // Trigger a given event with optional arguments.

  }, {
    key: "emit",
    value: function emit(type) {
      var listeners = this[EVENTS_KEY][type];
      if (!listeners) return;
      var shallowListeners = listeners.slice();

      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      for (var i = 0; i < shallowListeners.length; i++) {
        var listener = shallowListeners[i]; // @ts-ignore

        if (listener.$once) {
          this.off(type, listener);
        }

        listener.apply(this, args);
      }
    } // Get the event listeners or all event listeners.

  }, {
    key: "getListeners",
    value: function getListeners(type) {
      if (type) {
        return this[EVENTS_KEY][type] || [];
      }

      return (0, _flattenEvents["default"])(this[EVENTS_KEY]);
    }
  }]);
  return Emitter;
}();

var _default = Emitter;
exports["default"] = _default;
module.exports = exports.default;