"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = jsonp;

var _insertScript = _interopRequireDefault(require("./dom/insertScript"));

function jsonp(url) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return new Promise(function (resolve, reject) {
    var _options$callback = options.callback,
        callback = _options$callback === void 0 ? '_callback' : _options$callback,
        _options$responseType = options.responseType,
        responseType = _options$responseType === void 0 ? 'json' : _options$responseType,
        _options$timeout = options.timeout,
        timeout = _options$timeout === void 0 ? 0 : _options$timeout;
    var callbackName = "_callback".concat(Date.now());
    var hasQuestion = url.indexOf('?') > -1;
    var src = url;

    if (hasQuestion) {
      src += '&';
    } else {
      src += '?';
    }

    src += "".concat(encodeURIComponent(callback), "=").concat(encodeURIComponent(callbackName));
    var timerId;

    if (timeout) {
      // use `window.setTimeout` instead of `setTimeout` directly because type check
      timerId = window.setTimeout(function () {
        reject(new Error("the request is timeout ".concat(timeout, "ms")));
      }, timeout);
    } // @ts-ignore


    window[callbackName] = function (text) {
      if (timerId) clearTimeout(timerId);

      if (responseType === 'json') {
        try {
          resolve(JSON.parse(text));
        } catch (err) {
          reject(err);
        }
      } else {
        resolve(text);
      }
    };

    (0, _insertScript["default"])(src, {
      onerror: function onerror() {
        reject(new Error('load error'));
      }
    });
  });
}

module.exports = exports.default;