"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = parse;

function parse() {
  var search = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var queryString = search.charAt(0) === '?' ? search.slice(1) : search;
  var reArrayName = /^[\w\W]+\[\]$/;
  var query = {};
  queryString.split('&').forEach(function (part) {
    if (part) {
      var equalSignIndex = part.indexOf('=');
      var nameString = equalSignIndex > -1 ? part.slice(0, equalSignIndex) : part;
      var valueString = equalSignIndex > -1 ? part.slice(equalSignIndex + 1) : '';
      var name = decodeURIComponent(nameString);
      var value = decodeURIComponent(valueString);

      if (reArrayName.test(name)) {
        name = name.slice(0, -2);

        if (!query[name]) {
          query[name] = [value];
          return;
        }
      }

      if (query[name]) {
        if (!Array.isArray(query[name])) {
          query[name] = [query[name]];
        }

        ;
        query[name].push(value);
      } else {
        query[name] = value;
      }
    }
  });
  return query;
}

module.exports = exports.default;