"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = stringify;

var _hasOwn = _interopRequireDefault(require("../_internal/hasOwn"));

var _isObject = _interopRequireDefault(require("../lang/isObject"));

function stringify(query) {
  var pairs = [];
  /* istanbul ignore else */

  if ((0, _isObject["default"])(query)) {
    for (var name in query) {
      /* istanbul ignore else */
      if ((0, _hasOwn["default"])(query, name)) {
        var _ret = function () {
          var value = query[name];
          var encodedName = encodeURIComponent(name);

          if (Array.isArray(value)) {
            value.forEach(function (v) {
              pairs.push("".concat(encodedName, "=").concat(encodeURIComponent(v)));
            });
          } else if (value === undefined) {
            return "continue";
          } else if (value === null) {
            pairs.push("".concat(encodedName, "="));
          } else {
            pairs.push("".concat(encodedName, "=").concat(encodeURIComponent(value)));
          }
        }();

        if (_ret === "continue") continue;
      }
    }
  }

  return pairs.join('&');
}

module.exports = exports.default;