"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = truncate;

var _isCJK = _interopRequireDefault(require("../char/isCJK"));

function truncate() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var length = options.length,
      _options$omission = options.omission,
      omission = _options$omission === void 0 ? '...' : _options$omission,
      _options$countType = options.countType,
      countType = _options$countType === void 0 ? 0 : _options$countType;
  var ensureStr = String(str);
  var len = ensureStr.length;
  var countLen = length || len;
  var fullCount = countType === 1 ? 2 : 1;
  var halfCount = countType === 2 ? 0.5 : 1;
  var count = 0;
  var i = 0;

  for (; i < len; i++) {
    if ((0, _isCJK["default"])(ensureStr.charAt(i))) {
      count += fullCount;
    } else {
      count += halfCount;
    }

    if (count > countLen) {
      break;
    }
  }

  var truncatedStr = ensureStr.slice(0, i);
  return "".concat(truncatedStr).concat(truncatedStr.length < ensureStr.length ? omission : '');
}

module.exports = exports.default;