"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _isBrowser = _interopRequireDefault(require("../../_internal/isBrowser"));

// Ref: https://github.com/mumuy/browser
var testMap = {
  Windows: /Windows/,
  MacOS: /Macintosh/,
  Linux: /Linux|X11/,
  Android: /Android|Adr/,
  IOS: /like Mac OS X/,
  Mobile: /Mobi|iPh|480/,
  Tablet: /Tablet|Pad|Nexus 7/,
  Alipay: /AlipayClient/,
  WeChat: /MicroMessenger/,
  IPhone: /iPhone|iPod/,
  IPad: /iPad/
};
var userAgent = _isBrowser["default"] ? window.navigator.userAgent : '';

function _default(type) {
  return function () {
    var ua = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : userAgent;
    return testMap[type].test(ua);
  };
}

module.exports = exports.default;