"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = parse;

var _isString = _interopRequireDefault(require("../lang/isString"));

var _parse = _interopRequireDefault(require("../qs/parse"));

var reUrl = /^(\w{1,63}):\/\/(?:(\w+)(?::(\w+))?@)?([^\s@:/?#]{1,253})(?::(\d{1,5}))?(\/[^\s?#]+)?(\?[^#]+)?(#[\w\W]+)?$/;

function parse(url) {
  if (!(0, _isString["default"])(url)) {
    throw new TypeError('invalid url');
  }

  var matched = url.match(reUrl);

  if (!matched) {
    throw new TypeError('invalid url');
  }

  var protocol = matched[1];
  var username = matched[2] || '';
  var password = matched[3] || '';
  var hostname = matched[4];
  var port = matched[5] || '';
  var pathname = matched[6] || '';
  var search = matched[7] || '';
  var hash = matched[8] || '';
  var host = "".concat(hostname).concat(port ? ":".concat(port) : '');
  var origin = "".concat(protocol, "://").concat(host);
  var query = (0, _parse["default"])(search);
  return {
    hash: hash,
    host: host,
    hostname: hostname,
    href: url,
    origin: origin,
    password: password,
    pathname: pathname,
    port: port,
    protocol: protocol,
    query: query,
    search: search,
    username: username
  };
}

module.exports = exports.default;